/*************************************************************************/ /*
 VSPM

 Copyright (C) 2013-2014 Renesas Electronics Corporation

 License        Dual MIT/GPLv2

 The contents of this file are subject to the MIT license as set out below.

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 Alternatively, the contents of this file may be used under the terms of
 the GNU General Public License Version 2 ("GPL") in which case the provisions
 of GPL are applicable instead of those above.

 If you wish to allow use of your version of this file only under the terms of
 GPL, and not to allow others to use your version of this file under the terms
 of the MIT license, indicate your decision by deleting the provisions above
 and replace them with the notice and other provisions required by GPL as set
 out in the file called "GPL-COPYING" included in this distribution. If you do
 not delete the provisions above, a recipient may use your version of this file
 under the terms of either the MIT license or GPL.

 This License is also included in this distribution in the file called
 "MIT-COPYING".

 EXCEPT AS OTHERWISE STATED IN A NEGOTIATED AGREEMENT: (A) THE SOFTWARE IS
 PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 PURPOSE AND NONINFRINGEMENT; AND (B) IN NO EVENT SHALL THE AUTHORS OR
 COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


 GPLv2:
 If you wish to use this file under the terms of GPL, following terms are
 effective.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; version 2 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/ /*************************************************************************/

#ifndef VSPM_IP_H
#define VSPM_IP_H

#define VSPM_IPCTRL_VSPS_WPF_CH0	((0x00000001UL) << VSPM_TYPE_VSP_CH0)
#define VSPM_IPCTRL_VSPS_WPF_CH1	((0x00000001UL) << VSPM_TYPE_VSP_CH1)
#define VSPM_IPCTRL_VSPS_WPF_CH2	((0x00000001UL) << VSPM_TYPE_VSP_CH2)
#define VSPM_IPCTRL_VSPS_WPF_CH3	((0x00000001UL) << VSPM_TYPE_VSP_CH3)

#define VSPM_IPCTRL_VSPR_WPF_CH0	((0x00000001UL) << VSPM_TYPE_VSP_CH4)
#define VSPM_IPCTRL_VSPR_WPF_CH1	((0x00000001UL) << VSPM_TYPE_VSP_CH5)
#define VSPM_IPCTRL_VSPR_WPF_CH2	((0x00000001UL) << VSPM_TYPE_VSP_CH6)
#define VSPM_IPCTRL_VSPR_WPF_CH3	((0x00000001UL) << VSPM_TYPE_VSP_CH7)

#define VSPM_IPCTRL_VSPD0_WPF_CH0	((0x00000001UL) << VSPM_TYPE_VSP_CH8)
#define VSPM_IPCTRL_VSPD1_WPF_CH0	((0x00000001UL) << VSPM_TYPE_VSP_CH9)

#define VSPM_IPCTRL_2DDMAC_CH0		((0x00000001UL) << VSPM_TYPE_2DDMAC_CH0)
#define VSPM_IPCTRL_2DDMAC_CH1		((0x00000001UL) << VSPM_TYPE_2DDMAC_CH1)
#define VSPM_IPCTRL_2DDMAC_CH2		((0x00000001UL) << VSPM_TYPE_2DDMAC_CH2)
#define VSPM_IPCTRL_2DDMAC_CH3		((0x00000001UL) << VSPM_TYPE_2DDMAC_CH3)
#define VSPM_IPCTRL_2DDMAC_CH4		((0x00000001UL) << VSPM_TYPE_2DDMAC_CH4)
#define VSPM_IPCTRL_2DDMAC_CH5		((0x00000001UL) << VSPM_TYPE_2DDMAC_CH5)
#define VSPM_IPCTRL_2DDMAC_CH6		((0x00000001UL) << VSPM_TYPE_2DDMAC_CH6)
#define VSPM_IPCTRL_2DDMAC_CH7		((0x00000001UL) << VSPM_TYPE_2DDMAC_CH7)

#define VSPM_IPCTRL_VSP_RPF_CH0		((0x00000001UL) << VSPM_TYPE_RPF_CH0)
#define VSPM_IPCTRL_VSP_RPF_CH1		((0x00000001UL) << VSPM_TYPE_RPF_CH1)
#define VSPM_IPCTRL_VSP_RPF_CH2		((0x00000001UL) << VSPM_TYPE_RPF_CH2)
#define VSPM_IPCTRL_VSP_RPF_CH3		((0x00000001UL) << VSPM_TYPE_RPF_CH3)
#define VSPM_IPCTRL_VSP_RPF_CH4		((0x00000001UL) << VSPM_TYPE_RPF_CH4)

#define VSPM_IPCTRL_VSP_UDS_CH0		((0x00000001UL) << VSPM_TYPE_UDS_CH0)
#define VSPM_IPCTRL_VSP_UDS_CH1		((0x00000001UL) << VSPM_TYPE_UDS_CH1)
#define VSPM_IPCTRL_VSP_UDS_CH2		((0x00000001UL) << VSPM_TYPE_UDS_CH2)

#endif /* VSPM_IP_H */
